# Version of OpenSSH
%define oversion 3.4p1

# Version of ssh-askpass
%define aversion 1.2.2

# Do we want to disable building of x11-askpass? (1=yes 0=no)
%define no_x11_askpass 0

# Do we want to disable building of gnome-askpass? (1=yes 0=no)
%define no_gnome_askpass 0

# get openssl version
%define openssl_version %(rpm -q openssl | cut -d - -f 2)

%define _prefix /usr

#%define	privseppath /var/lib/openssh

Summary: OpenSSH free Secure Shell (SSH) implementation
Summary: OpenSSH ѵİȫShell.
Name: openssh
Version: %{oversion}
Release: 6.1ml
Serial: 2003091701
URL: http://www.openssh.com/
Source0: ftp://ftp.openbsd.org/pub/OpenBSD/OpenSSH/portable/openssh-%{oversion}.tar.gz
Source1: http://www.ntrnet.net/~jmknoble/software/x11-ssh-askpass/x11-ssh-askpass-%{aversion}.tar.gz 
Source2: sshd.init
Patch0: openssh-sshd_config-ml.patch
Patch1: openssh-2.9p1-groups.patch 
Patch3: openssh-TODO.patch 
Patch4: openssh-3.4p1-hostauth.patch 
Patch5: openssh-3.4p1-pam-timing.patch 
Patch6: openssh-buffer-size.patch
Patch7: openssh-3.5p1-skip-initial.patch
Patch8: openssh-3.4p1-scp-fix.diff

License: BSD
Group: Applications/Internet
BuildRoot: /var/tmp/%{name}-%{version}-%{release}-root
Obsoletes: ssh ssh2
PreReq: openssl = %{openssl_version} tcp_wrappers
PreReq: grep, textutils, fileutils, findutils, shadow-utils, setup
Requires: openssl = %{openssl_version} pam >= 0.72-6
BuildPreReq: perl openssl-devel tcp_wrappers-devel pam
%if ! %{no_gnome_askpass}
BuildPreReq: gnome-libs-devel
%endif
#NoSource: 0
#NoSource: 1
#NoPatch: 5

%package clients
Summary: OpenSSH Secure Shell protocol clients
Summary(zh_CN): OpenSHH ͻ˳.
Requires: openssh
Group: Applications/Internet
Obsoletes: ssh-clients
Provides: ssh-clients

%package server
Summary: OpenSSH Secure Shell protocol server (sshd)
Summary(zh_CN): OpenSSH ˳(sshd).
Group: System Environment/Daemons
Obsoletes: ssh-server
Provides: ssh-server sshd
PreReq: openssh chkconfig >= 0.9

%package askpass
Summary: OpenSSH X11 passphrase dialog
Summary(zh_CN): OpenSSH X11 passphrase dialog
Group: Applications/Internet
Requires: openssh
Obsoletes: ssh-extras

%package askpass-gnome
Summary: OpenSSH GNOME passphrase dialog
Group: Applications/Internet
Requires: openssh
Obsoletes: ssh-extras

%description
Ssh (Secure Shell) a program for logging into a remote machine and for
executing commands in a remote machine.  It is intended to replace
rlogin and rsh, and provide secure encrypted communications between
two untrusted hosts over an insecure network.  X11 connections and
arbitrary TCP/IP ports can also be forwarded over the secure channel.

OpenSSH is OpenBSD's rework of the last free version of SSH, bringing it
up to date in terms of security and features, as well as removing all 
patented algorithms to seperate libraries (OpenSSL).
n
This package includes the core files necessary for both the OpenSSH
client and server.  To make this package useful, you should also
install openssh-clients, openssh-server, or both.

%description clients
Ssh (Secure Shell) a program for logging into a remote machine and for
executing commands in a remote machine.  It is intended to replace
rlogin and rsh, and provide secure encrypted communications between
two untrusted hosts over an insecure network.  X11 connections and
arbitrary TCP/IP ports can also be forwarded over the secure channel.

OpenSSH is OpenBSD's rework of the last free version of SSH, bringing it
up to date in terms of security and features, as well as removing all 
patented algorithms to seperate libraries (OpenSSL).

This package includes the clients necessary to make encrypted connections
to SSH servers.

%description server
Ssh (Secure Shell) a program for logging into a remote machine and for
executing commands in a remote machine.  It is intended to replace
rlogin and rsh, and provide secure encrypted communications between
two untrusted hosts over an insecure network.  X11 connections and
arbitrary TCP/IP ports can also be forwarded over the secure channel.

OpenSSH is OpenBSD's rework of the last free version of SSH, bringing it
up to date in terms of security and features, as well as removing all 
patented algorithms to seperate libraries (OpenSSL).

This package contains the secure shell daemon. The sshd is the server 
part of the secure shell protocol and allows ssh clients to connect to 
your host.

%description askpass
Ssh (Secure Shell) a program for logging into a remote machine and for
executing commands in a remote machine.  It is intended to replace
rlogin and rsh, and provide secure encrypted communications between
two untrusted hosts over an insecure network.  X11 connections and
arbitrary TCP/IP ports can also be forwarded over the secure channel.

OpenSSH is OpenBSD's rework of the last free version of SSH, bringing it
up to date in terms of security and features, as well as removing all 
patented algorithms to seperate libraries (OpenSSL).

This package contains Jim Knoble's <jmknoble@pobox.com> X11 passphrase 
dialog.

%description askpass-gnome
Ssh (Secure Shell) a program for logging into a remote machine and for
executing commands in a remote machine.  It is intended to replace
rlogin and rsh, and provide secure encrypted communications between
two untrusted hosts over an insecure network.  X11 connections and
arbitrary TCP/IP ports can also be forwarded over the secure channel.

OpenSSH is OpenBSD's rework of the last free version of SSH, bringing it
up to date in terms of security and features, as well as removing all 
patented algorithms to seperate libraries (OpenSSL).

This package contains the GNOME passphrase dialog.

%changelog
* Thu Apr 1 2004 Shiro Yamada <shiro@miraclelinux.com> 3.4p1-6.1ml
- apply a patch for the scp bug (patch 8)

* Fri Aug 1 2003 Jun YOSHIDA <jun@miraclelinux.com>
- for security fix.

* Thu Jun 27 2002 Jun YOSHIDA <jun@miraclelinux.com> 3.4p1
- upgraded to 3.4p1

* Fri Mar 8 2002 Masaru Yokoi <masaru@turbolinux.co.jp> 2.9p2-7,
- security: added pine-cert20020301 patch.

* Mon Dec 10 2001 Masaru Yokoi <masaru@turbolinux.co.jp>
- added security fix patch for "UseLogin" option.
- added xauth patch. refuse to do X11 forwarding if xauth isn't there.
 
* Wed Oct 17 2001 Go Taniguchi <go@turbolinux.co.jp>
- secrity fix key.c ret code change

* Wed Sep 12 2001 Toshihiro Yamagishi<toshihiro@turbolinux.co.jp>
- added openssh-LinuxHang.patch (#03163)

* Thu Jul 12 2001 Toshihiro Yamagishi<toshihiro@turbolinux.co.jp>
- added securlevel in sshd.init

* Wed Jul 11 2001 Toshihiro Yamagishi<toshihiro@turbolinux.co.jp>
- rebuild for openssl-0.9.6b

* Wed Jun 20 2001 Toshihiro Yamagishi<toshihiro@turbolinux.co.jp>
- updated to 2.9p2(security fixed)

* Tue Jun 12 2001 Toshihiro Yamagishi<toshihiro@turbolinux.co.jp>
- updated x11-ssh-askpass to 1.2.2

* Tue May  8 2001 Toshihiro Yamagishi<toshihiro@turbolinux.co.jp>
- updated to 2.9p1

* Thu Apr 26 2001 Toshihiro Yamagishi<toshihiro@turbolinux.co.jp>
- added 'DSAAuthentication yes' in sshd_conf

* Mon Apr 23 2001 Toshihiro Yamagishi<toshihiro@turbolinux.co.jp>
- remove pam version requirement ( pam >= 0.72-6)
- updated to 2.5.2p2

* Thu Apr 5 2001 Go Taniguchi <go@turbolinux.co.jp>
- support LFS

* Wed Mar 28 2001 Toshihiro Yamagishi<toshihiro@turbolinux.co.jp>
- added requirement of pam >= 0.74
- added provides sshd in server package

* Fri Mar 23 2001 Toshihiro Yamagishi<toshihiro@turbolinux.co.jp>
- updated to 2.5.2p1

* Sat Mar  3 2001 Toshihiro Yamagishi<toshihiro@turbolinux.co.jp>
- updated to 2.5.1p2
- added sftp-server and sftp-client in openssh-server and openssh-client
- added --with-pam at configure

* Wed Feb 27 2001 Merlin Ma <merlin@turbolinux.com.cn>
- Updated to 2.5.1p1

* Fri Jan 26 2001 Kazutomo Yoshii <kazutomo@turbolinux.co.jp>
- adjusted Prereq

* Fri Jan 19 2001 Toshihiro Yamagishi<toshihiro@turbolinux.co.jp>
- added sftp-server in openssh-server package

* Thu Jan 11 2001 Toshihiro Yamagishi<toshihiro@turbolinux.co.jp>
- comment the part of post section which restart daemon.
    
* Wed Jan 10 2001 Toshihiro Yamagishi<toshihiro@turbolinux.co.jp>
- deleted the part of post section which start daemon forcibly.
  because, we can't unmount cdrom when update/install openssh from cd-rom.

* Mon Jan 5 2001 Roger Luethi <rluethi@turbolinux.com>
- 2.3.0p1-6: fixed typo in 2.3.0p1-5 changes

* Mon Jan 1 2001 Roger Luethi <rluethi@turbolinux.com>
- 2.3.0p1-5
- added openssh-2.3.0p1-delay_after_failed_login.patch (changes pam config)
- added openssh-2.1.1p4-change_pam_name_from_sshd_to_ssh.patch (be consistent
  with other services)
- additional BuildPreReq: pam
- create /etc/ssh/ssh_host_key and /etc/ssh/ssh_host_dsa_key in %post if they
  don't exist
- start sshd in %post (we already "chkconfig --add" and restart)
- add sftp-server and ssh-copy-id (fix sftp-server line in /etc/ssh/sshd_config)
- moved files from /usr/libexec to /usr/lib/ssh (FHS)
- added documentation: RFC.nroff, TODO

* Tue Dec 26 2000 Kazutomo Yoshii <kazutomo@turbolinux.co.jp>
- %post section : add sshd : ALL to hosts.allow 

* Mon Dec  4 2000 Toshihiro Yamagishi<toshihiro@turbolinux.co.jp>
- fixed sshd.init script
* Thu Nov  9 2000 Toshihiro Yamagishi<toshihiro@turbolinux.co.jp>
- update to 2.3.0p1
* Wed Oct  4 2000 Toshihiro Yamagishi<toshihiro@turbolinux.co.jp>
- added -6 option when sshd start
* Wed Sep 27 2000 Toshihiro Yamagishi<toshihiro@turbolinux.co.jp>
- rebuild for TurboLinux
* Tue Aug 08 2000 Damien Miller <djm@mindrot.org>
- Some surgery to sshd.init (generate keys at runtime)
- Cleanup of groups and removal of keygen calls
* Wed Jul 12 2000 Damien Miller <djm@mindrot.org>
- Make building of X11-askpass and gnome-askpass optional
* Mon Jun 12 2000 Damien Miller <djm@mindrot.org>
- Glob manpages to catch compressed files
* Wed Mar 15 2000 Damien Miller <djm@ibs.com.au>
- Updated for new location
- Updated for new gnome-ssh-askpass build
* Sun Dec 26 1999 Damien Miller <djm@mindrot.org>
- Added Jim Knoble's <jmknoble@pobox.com> askpass
* Mon Nov 15 1999 Damien Miller <djm@mindrot.org>
- Split subpackages further based on patch from jim knoble <jmknoble@pobox.com>
* Sat Nov 13 1999 Damien Miller <djm@mindrot.org>
- Added 'Obsoletes' directives
* Tue Nov 09 1999 Damien Miller <djm@ibs.com.au>
- Use make install
- Subpackages
* Mon Nov 08 1999 Damien Miller <djm@ibs.com.au>
- Added links for slogin
- Fixed perms on manpages
* Sat Oct 30 1999 Damien Miller <djm@ibs.com.au>
- Renamed init script
* Fri Oct 29 1999 Damien Miller <djm@ibs.com.au>
- Back to old binary names
* Thu Oct 28 1999 Damien Miller <djm@ibs.com.au>
- Use autoconf
- New binary names
* Wed Oct 27 1999 Damien Miller <djm@ibs.com.au>
- Initial RPMification, based on Jan "Yenya" Kasprzak's <kas@fi.muni.cz> spec.

%prep
rm -rf $RPM_BUILD_ROOT

%setup -q -a 1
#cp -f %{SOURCE3} sshd_config
%patch0 -p1
%patch1 -p1
%patch3 -p0
%patch4 -p0
%patch5 -p1
%patch6 -p0 -b .buffer-size
%patch7 -p1 -b .skip-initial
%patch8 -p0 -b .scp

%build
CFLAGS="$RPM_OPT_FLAGS -DNO_IDEA" \
	./configure --prefix=%{_prefix} \
                    --infodir=%{_infodir} \
                    --mandir=%{_mandir} \
                    --sysconfdir=/etc/ssh \
                    --libexecdir=/usr/lib/ssh \
                    --with-pam \
                    --with-tcp-wrappers \
                    --with-ipv4-default \
                    --with-md5-passwords \
                    --with-rsh=/usr/bin/rsh \
		    --without-privsep-user \
		    --without-privsep-path

make

%if ! %{no_x11_askpass}
cd x11-ssh-askpass-%{aversion}
./configure --prefix=%{_prefix} --mandir=%{_mandir}
xmkmf
make includes
make
cd ..
%endif

%if ! %{no_gnome_askpass}
cd contrib
gcc -O -g `gnome-config --cflags gnome gnomeui` \
        gnome-ssh-askpass.c -o gnome-ssh-askpass \
        `gnome-config --libs gnome gnomeui`
cd ..
%endif

%install
make install DESTDIR=$RPM_BUILD_ROOT/

install -d $RPM_BUILD_ROOT/etc/pam.d/
install -d $RPM_BUILD_ROOT/etc/rc.d/init.d
install -d $RPM_BUILD_ROOT/%{_prefix}/lib/ssh
install -m644 contrib/redhat/sshd.pam $RPM_BUILD_ROOT/etc/pam.d/sshd
install -m755 contrib/ssh-copy-id $RPM_BUILD_ROOT/usr/bin
install -m644 contrib/ssh-copy-id.1 $RPM_BUILD_ROOT/%{_mandir}/man1
install -m755 %{SOURCE2} $RPM_BUILD_ROOT/etc/rc.d/init.d/sshd
#[ ! -d %{privseppath} ] && mkdir -p %{privseppath}

perl -pi -e 's,/usr/local/sbin/sftpd,/usr/lib/ssh/sftp-server,' \
	$RPM_BUILD_ROOT/etc/ssh/sshd_config

%if ! %{no_x11_askpass}
install -s x11-ssh-askpass-%{aversion}/x11-ssh-askpass $RPM_BUILD_ROOT/usr/lib/ssh/x11-ssh-askpass
ln -s x11-ssh-askpass $RPM_BUILD_ROOT/usr/lib/ssh/ssh-askpass
%endif

%if ! %{no_gnome_askpass}
install -s contrib/gnome-ssh-askpass $RPM_BUILD_ROOT/usr/lib/ssh/gnome-ssh-askpass
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post server
if [ "$1" = 1 ] ; then
  /sbin/chkconfig --add sshd
fi

# added entry to tcp_wrapper
if ! grep "^sshd" /etc/hosts.allow > /dev/null ; then 
	echo "sshd : ALL" >> /etc/hosts.allow
fi

#id=27
#grep '^sshd:' /etc/group > /dev/null 2>&1
#if [ $? '!=' 0 ] ; then
#    while : ; do
#        cat /etc/group | awk -F: '{print $3}' | grep "^$id$" > /dev/null 2>&1
#        if [ $? '!=' 0 ] ; then
#            cat /etc/passwd | awk -F: '{print $3}' | grep "^$id$" > /dev/null 2>&1
#            if [ $? '!=' 0 ] ; then
#                break
#            fi
#        fi
#        id=$(($id+1))
#    done
#    groupadd -g $id sshd
#fi
#grep '^sshd:' /etc/passwd > /dev/null 2>&1
#if [ $? '!=' 0 ] ; then
#    useradd -u $id -g $id -g sshd -d %{privseppath} -c 'ssh prisep' -s /sbin/nologin sshd
## keep /var/lib/openssh empty.
#    find %{privseppath} -type f -exec rm -f {} \;
#fi

%preun server
if [ "$1" = 0 ] ; then
  /etc/rc.d/init.d/sshd stop >&2
  /sbin/chkconfig --del sshd
fi


%files
%defattr(-,root,root)
%doc ChangeLog OVERVIEW README* INSTALL RFC.nroff TODO
%doc CREDITS LICENCE
%attr(0755,root,root) %{_prefix}/bin/ssh-keygen
%attr(0755,root,root) %{_prefix}/bin/scp
%attr(0755,root,root) %{_prefix}/bin/ssh-keyscan
%attr(0644,root,root) %{_mandir}/man1/ssh-keygen.1*
%attr(0644,root,root) %{_mandir}/man1/ssh-keyscan.1*
%attr(0644,root,root) %{_mandir}/man1/scp.1*
%attr(0755,root,root) %dir /etc/ssh
%attr(0755,root,root) %config(noreplace) /etc/ssh/moduli
%attr(0755,root,root) %dir %{_prefix}/lib/ssh

%files clients
%defattr(-,root,root)
%attr(4755,root,root) %{_prefix}/bin/ssh
%attr(0755,root,root) %{_prefix}/bin/ssh-agent
%attr(0755,root,root) %{_prefix}/bin/ssh-add
%attr(0755,root,root) %{_prefix}/bin/ssh-copy-id
%attr(0755,root,root) %{_prefix}/bin/sftp
%attr(0644,root,root) %{_mandir}/man1/ssh.1*
%attr(0644,root,root) %{_mandir}/man1/ssh-agent.1*
%attr(0644,root,root) %{_mandir}/man1/ssh-add.1*
%attr(0644,root,root) %{_mandir}/man1/ssh-copy-id.1*
%attr(0644,root,root) %{_mandir}/man1/sftp.1*
%attr(0644,root,root) %config(noreplace) /etc/ssh/ssh_config
%attr(-,root,root) %{_prefix}/bin/slogin
%attr(-,root,root) %{_mandir}/man1/slogin.1*

%files server
%defattr(-,root,root)
%attr(0755,root,root) %{_prefix}/sbin/sshd
%attr(0755,root,root) %{_prefix}/lib/ssh/sftp-server
%attr(0644,root,root) %{_mandir}/man8/sshd.8*
%attr(0644,root,root) %{_mandir}/man8/sftp-server.8*
%attr(0600,root,root) %config(noreplace) /etc/ssh/sshd_config
%attr(0600,root,root) %config(noreplace) /etc/pam.d/sshd
%attr(0755,root,root) %config /etc/rc.d/init.d/sshd
#%attr(0755,root,root) %dir %{privseppath}

%if ! %{no_x11_askpass}
%files askpass
%defattr(-,root,root)
%doc x11-ssh-askpass-%{aversion}/README
%doc x11-ssh-askpass-%{aversion}/ChangeLog
%doc x11-ssh-askpass-%{aversion}/SshAskpass*.ad
%attr(0755,root,root) /usr/lib/ssh/ssh-askpass
%attr(0755,root,root) /usr/lib/ssh/x11-ssh-askpass
%endif

%if ! %{no_gnome_askpass}
%files askpass-gnome
%defattr(-,root,root)
%attr(0755,root,root) /usr/lib/ssh/gnome-ssh-askpass
%endif
